#ifndef __ABNGPOLLER_HH
#define __ABNGPOLLER_HH

#include "process_status.hh"
#include "poller.h"

#define STATION_STATUS_REPLY    0x62
#define CHALLENGE_REPLY         0x40
#define SET_HOME_REPLY          0x41
#define BEEPER_REPLY            0x42
#define SET_STATE_REPLY         0x43
#define DEVICE_STATUS_REPLY     0x44
#define GET_HOME_REPLY          0x47
#define AUTODIAGNOSTIC_REPLY    0x68
#define GET_PORT_COMMAND_REPLY  0x63
#define SIGHT_PERIODIC          0x80
#define SIGHT_SIDE_BUT          0x81
#define SIGHT_MIDDLE_BUT        0x82
#define SIGHT_FIELD_PERIODIC    0x84 // badge in field
#define SIGHT_FIELD_SIDE_BUT    0x85
#define SIGHT_FIELD_MIDDLE_BUT  0x86
#define SIGHT_UFIELD_PERIODIC   0x88 // badge in unrecognised field
#define SIGHT_UFIELD_SIDE_BUT   0x89
#define SIGHT_UFIELD_MIDDLE_BUT 0x8a


#define MAX_SERIAL_LINES        16
#define FS                      3    // first serial line file descriptor number 


void usage(void);
void ORLInit();
int ABngInit(int argc, char **argv);
int IsABngInitialised();
void ABngInitialise();
void ORBThread(void *attrs);
void ORLPollThread(void *attrs);
void OlivettiPollThread(void *attrs);
void ProcessMessagesThread(void *attrs);
void EfficiencyThread(void *attrs);
void FromNetToSensors();
void FromSensorsToNet();
void CorbaSendMessage(PollerMessage *pPtr);
void ObserverInvokeMethod( SABobserver* cur_obs, 
		      PollerMessage *pPtr,
		      ABng_Poller::AB_Poller::Time_Stamp *ts,
		      unsigned char station,
		      unsigned char message_type,
		      unsigned char length,
		      unsigned char network_nr,
		      unsigned char checksum
		      );

void  seqcpy(_CORBA_Unbounded_Sequence__Octet &o, unsigned char* str, unsigned int l);
void CorbaAddMessage(SocketMessage *sPtr);
SocketMessage *CorbaRX();


class PollerStatus : public ServerStatusInterface {
public:
  virtual void get_server_status( ostream &ostr);
};  

#endif
