#include "abpoller2_i.hh"
#include <iostream.h>

void
AB_Poller_V2_i::get_output(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  cout << "Network: " << (int)network << endl;
	  cout << "Station: " << (int)station << endl;
     }

     msg.length(5);
     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xE3;
     msg[3] = 0x00;
     msg[4] = network;

     issue_command(msg);
}

void
AB_Poller_V2_i::configure(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station, ABng_Poller::AB_Poller_V2::Speed speed_value, ABng_Poller::AB_Poller_V2::Stop stop_value, ABng_Poller::AB_Poller_V2::Parity parity_value, ABng_Poller::AB_Poller::Byte chars_value)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  cout << "Network: " << (int)network << endl;
	  cout << "Station: " << (int)station << endl;
	  cout << "Speed value: " << speed_value << endl;
	  cout << "Stop value: " << stop_value << endl;
	  cout << "Parity value: " << parity_value << endl;
	  cout << "Chars value: " << (int)chars_value << endl;
     }

     msg.length(9);
     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xE7;
     msg[3] = 0x04;
     msg[4] = speed_value;
     msg[5] = stop_value;
     msg[6] = parity_value;
     msg[7] = chars_value;
     msg[8] = network;

     issue_command(msg);
}

void
AB_Poller_V2_i::autodiagnostic(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  cout << "Network: " << (int)network << endl;
	  cout << "Station: " << (int)station << endl;
     }

     msg.length(4);
     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xE8;
     msg[3] = network;

     issue_command(msg);
}

void
AB_Poller_V2_i::go_off_line(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  cout << "Network: " << (int)network << endl;
	  cout << "Station: " << (int)station << endl;
     }

     msg.length(4);
     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xE9;
     msg[4] = network;
     issue_command(msg);
}

void
AB_Poller_V2_i::broadoff(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  cout << "Network: " << (int)network << endl;
	  cout << "Station: " << (int)station << endl;
     }

     msg.length(4);
     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xEA;
     msg[3] = network;

     issue_command(msg);
}

void 
AB_Poller_V2_i::sensor_config(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station, ABng_Poller::AB_Poller_V2::Mode mode)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  cout << "Network: " << (int)network << endl;
	  cout << "Station: " << (int)station << endl;
	  cout << "Mode: " << mode << endl;
     }

     msg.length(5);

     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xEB;
     msg[3] = mode;
     msg[4] = network;

     issue_command(msg);
}

void
AB_Poller_V2_i::poll(ABng_Poller::AB_Poller::Network_Id network, ABng_Poller::AB_Poller::Station_Id station)
{
     ABng_Poller::AB_Poller::Message	msg;

     if (_debug)
     {
	  //cout << "Network: " << (int)network << endl;
	  //cout << "Station: " << (int)station << endl;
     }

     msg.length(4);
     
     msg[0] = 0xFF;
     msg[1] = (unsigned char)station;
     msg[2] = 0xEF;
     msg[3] = network;

     issue_command(msg);
}

