#
# ABng poller
#

CC		  = /usr/local/bin/gcc
CXX		  = /usr/local/bin/g++

SRCS		  = poller.c serial.c socket.c

CXXSRCS           = sabpoller_i.cc abpoller_i.cc abpoller2_i.cc \
		    abngpoller.cc process_status.cc polconfig.cc	  
#CXXFLAGS          =

OBJS		  = socket.o  poller.o serial.o \
		    sabpoller_i.o abpoller_i.o abpoller2_i.o \
		    abngpoller.o process_status.o polconfig.o

CFGSRCS		  = polconfig.cc configtest.cc
CFGOBJS		 := $(CFGSRCS:.cc=.o)

DIR_CPPFLAGS      = $(CORBA_CPPFLAGS)

CORBA_INTERFACES  = abng_poller  abng_server_manager
#CXXDEBUGFLAGS	  = -O0 -g -pg
CXXDEBUGFLAGS	  = -w

ABNGPOLLER        = $(patsubst %,$(BinPattern),abngpoller)

LOGGER            = $(patsubst %,$(BinPattern),logger)

all:: $(ABNGPOLLER) $(LOGGER)

$(ABNGPOLLER): $(OBJS) $(CORBA_STUB_OBJS) $(CORBA_LIB_DEPEND)
	@(libs="$(CORBA_LIB)"; $(CXXExecutable))

tags:: TAGS

TAGS::	$(SRCS) $(CXXSRCS)
	etags *.{c,cc,h,hh}

configtest: $(CFGOBJS)
	$(CXX) -o $@ $(CFGOBJS)
	

SRCS           = logger.c
OBJS           = logger.o

$(LOGGER): $(OBJS) 
	@(libs=""; $(CXXExecutable))

export:: $(ABNGPOLLER)
	@$(ExportExecutable)

export:: $(LOGGER)
	@$(ExportExecutable)


clean::
	$(RM) $(ABNGPOLLER) $(LOGGER) *~ core *.d


