#ifndef __CONFIG_HH
#define __CONFIG_HH

#include <iostream.h>
#include <fstream.h>
#include <algo.h>
#include <vector.h>
#include <map.h>
#include <rope.h>
#include <function.h>

static void GlobalParamsDump( pair<const crope, crope> entry);
static void FreeStrings( pair<const crope, crope> entry);

#define CONFIG_FILE   "/etc/abngpoller.conf"
#define MAX_LINE      256
#define CONFIG_ERROR  "Config file syntax error in line "

#define LINE_OPEN     "<Line>"
#define LINE_CLOSE    "</Line>"


enum ELineType 
{
  ORLLine,
  OlivettiLine
};

struct ltstr
{
  bool operator()(const crope s1, const crope s2) const
  {
    return s1 < s2;
  }
};

class CPollerConfig
{
public:
  CPollerConfig() { ConfigFileName = CONFIG_FILE; }
  CPollerConfig( crope filename ){ConfigFileName = filename; }
  SetFileName( char *filename  ){ConfigFileName = (const char *)filename ;}
  void Init();
 ~CPollerConfig();
  int Read();
  int Write();
  void Dump();


private:
  void ErrorMessage(char *str);
  int debug;
  int CurLine;
  crope ConfigFileName;
  fstream ConfigFile;
public:
  map<const crope, crope, ltstr> GlobalParams, DefLineParams;
  vector< map<const crope, crope, ltstr>   > SerialLines;
};


//ostream& operator<<(ostream& os, CPollerConfig cfg);

#endif // __CONFIG_HH
