//
// $Id: process_status.hh,v 1.1 1998/06/16 12:56:04 mencnar Exp $
//
// $Log: process_status.hh,v $
// Revision 1.1  1998/06/16 12:56:04  mencnar
// Initial revision
//
//
//-----------------------------------------------------------------------------
// 
// Author:      Daniel Mencnarowski  (mencnar@ics.agh.edu.pl)
//
// Description: Header file
//              Implementation class for ABng_Server_Manager::ProcessControl
//

#ifndef __process_control_hh__
#define __process_control_hh__

#include "abng_server_manager.hh"
#include <sys/time.h>
#include <iostream.h>

class ServerStatusInterface {
public:
  virtual void get_server_status( ostream &ostr);
};

class ProcessControlImpl : ABng_Server_Manager::_sk_ProcessControl {
  ServerStatusInterface *status_impl;
  char *process_name;
  struct timeval start_time;
public:
  ProcessControlImpl( ABng_Server_Manager::Register_Manager_ptr srvman,
		      const char *_process_name,
		      ServerStatusInterface *_status_impl);
  ~ProcessControlImpl();

  // implementation of the IDL interface

  void kill_server();
  CORBA::Long get_pid( );
  char * get_host_name( );
  char * get_process_owner();
  CORBA::Long uptime();
  char * get_server_status();  
};

#endif // __process_control_h__

//




